Index: cpp/frams/model/model.h
===================================================================
--- cpp/frams/model/model.h	(revision 815)
+++ cpp/frams/model/model.h	(revision 896)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2018  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2019  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -77,5 +77,5 @@
 	SList parts, joints, neurons;
 	char partmappingchanged;
-	vector<Model*> checkpoints;
+	vector<Model *> checkpoints;
 
 	void internalCopy(const Model &mod);
@@ -141,5 +141,5 @@
 
 	int getCheckpointCount();
-	Model* getCheckpoint(int i);
+	Model *getCheckpoint(int i);
 
 	/// The bounding box size. Valid if the model is valid. Read only.
@@ -201,5 +201,5 @@
 
 	/// change source genotype
-	void setGeno(const Geno& newgeno);
+	void setGeno(const Geno &newgeno);
 
 	/** @return f0 genotype - generated from current model state
@@ -241,5 +241,5 @@
 		@see convmap
 		*/
-	void getCurrentToF0Map(MultiMap& m);
+	void getCurrentToF0Map(MultiMap &m);
 
 	void setValidationLevel(int level)
@@ -250,5 +250,5 @@
 	/// calculate location of the new part connected to the existing one
 	/// using delta option
-	Pt3D whereDelta(const Part& start, const Pt3D& rot, const Pt3D& delta);
+	Pt3D whereDelta(const Part &start, const Pt3D &rot, const Pt3D &delta);
 
 	/// create the whole model from scratch, using current genotype
@@ -256,5 +256,5 @@
 
 	/// setGeno(newgeno); rebuild();
-	void rebuild(const Geno& newgeno, bool buildmaps) { setGeno(newgeno); rebuild(buildmaps); }
+	void rebuild(const Geno &newgeno, bool buildmaps) { setGeno(newgeno); rebuild(buildmaps); }
 
 	/// reuse current model object but discard all model data
@@ -262,5 +262,5 @@
 
 	enum ItemType { UnknownType, ModelType, PartType, JointType, NeuronType, NeuronConnectionType, CheckpointType };
-	static ItemType itemTypeFromLinePrefix(const char* line);
+	static ItemType itemTypeFromLinePrefix(const char *line);
 	/** Execute single line of <B>f0</B> genotype.
 		Return value is non-negative reference number of the created item,
@@ -270,9 +270,9 @@
 		@param srcrange source genotype range which will be mapped to this element
 		*/
-	int addFromString(ItemType item_type, const SString &singleline, int line_num, const MultiRange* srcrange = NULL);
+	int addFromString(ItemType item_type, const SString &singleline, int line_num, const MultiRange *srcrange = NULL);
 	/** Execute single line of <B>f0</B> genotype - compatiblity variant */
-	int addFromString(ItemType item_type, const SString &singleline, const MultiRange* srcrange = NULL);
+	int addFromString(ItemType item_type, const SString &singleline, const MultiRange *srcrange = NULL);
 	/** Execute single line of <B>f0</B> genotype - low level variant, used by Model::build(), error messages returned as string instead of calling logger */
-	int addFromStringNoLog(ItemType item_type, const SString &singleline, SString& error_message, const MultiRange* srcrange = 0);
+	int addFromStringNoLog(ItemType item_type, const SString &singleline, SString &error_message, const MultiRange *srcrange = 0);
 
 	/// separate build stages (for future use)
@@ -357,9 +357,9 @@
 
 	/// @return part index or -1 if not found in the model
-	int findPart(Part* p);
+	int findPart(Part *p);
 	/// @return joint index or -1 if not found in the model
-	int findJoint(Joint* j);
+	int findJoint(Joint *j);
 	/// @return neuro index or -1 if not found in the model
-	int findNeuro(Neuro* nu);
+	int findNeuro(Neuro *nu);
 	/// @return joint index or -1 if not found in the model
 	int findJoint(Part *p1, Part *p2);
@@ -368,20 +368,20 @@
 		@param result objects will be appended here
 		@return number of objects found  */
-	int findNeuros(SList& result, const char* classname = 0, const Part* part = 0, const Joint* joint = 0);
+	int findNeuros(SList &result, const char *classname = 0, const Part *part = 0, const Joint *joint = 0);
 
 	/** search for joints connected to the part
 		@param result objects will be appended here
 		@return number of objects found  */
-	int findJoints(SList& result, const Part* part = 0);
+	int findJoints(SList &result, const Part *part = 0);
 
 	void disturb(double amount);
-	void move(const Pt3D& shift);
+	void move(const Pt3D &shift);
 	/// rotate around the origin (move-rotate-move to rotate around arbitrary point)
-	void rotate(const Orient& rotation);
+	void rotate(const Orient &rotation);
 	/// rotate around the origin (move-rotate-move to rotate around arbitrary point)
-	void rotate(const Pt3D& angles) { Orient o = Orient_1; o.rotate(angles); rotate(o); }
+	void rotate(const Pt3D &angles) { Orient o = Orient_1; o.rotate(angles); rotate(o); }
 
 	/// build this model using solid shape types, based on the provided ball-and-stick model. See also shapeconvert.cpp.
-	void buildUsingSolidShapeTypes(const Model& src_ballandstick_shapes, Part::Shape use_shape = Part::SHAPE_CYLINDER, double thickness = 0.2);
+	void buildUsingSolidShapeTypes(const Model &src_ballandstick_shapes, Part::Shape use_shape = Part::SHAPE_CYLINDER, double thickness = 0.2);
 
 protected:
@@ -403,17 +403,17 @@
 	static int mapToNeuro(int i);
 
-	static void makeGenToGenMap(MultiMap& result, const MultiMap& gen1tomodel, const MultiMap& gen2tomodel);
+	static void makeGenToGenMap(MultiMap &result, const MultiMap &gen1tomodel, const MultiMap &gen2tomodel);
 
 	///////////////////////////
 
-	static Part& getMinPart();
-	static Part& getMaxPart();
-	static Part& getDefPart();
-	static Joint& getMinJoint();
-	static Joint& getMaxJoint();
-	static Joint& getDefJoint();
-	static Neuro& getMinNeuro();
-	static Neuro& getMaxNeuro();
-	static Neuro& getDefNeuro();
+	static Part &getMinPart();
+	static Part &getMaxPart();
+	static Part &getDefPart();
+	static Joint &getMinJoint();
+	static Joint &getMaxJoint();
+	static Joint &getDefJoint();
+	static Neuro &getMinNeuro();
+	static Neuro &getMaxNeuro();
+	static Neuro &getDefNeuro();
 };
 
@@ -436,7 +436,7 @@
 	Model *converted_model;
 	Model *using_model;
-	SolidsShapeTypeModel(Model& m, Part::Shape use_shape = Part::SHAPE_CYLINDER, double thickness = 0.2);
-	operator Model&() { return *using_model; }
-	Model& getModel() { return *using_model; }
+	SolidsShapeTypeModel(Model &m, Part::Shape use_shape = Part::SHAPE_CYLINDER, double thickness = 0.2);
+	operator Model &() { return *using_model; }
+	Model &getModel() { return *using_model; }
 	~SolidsShapeTypeModel() { if (converted_model) delete converted_model; }
 };