Index: cpp/frams/config/f0-SDK.def
===================================================================
--- cpp/frams/config/f0-SDK.def	(revision 826)
+++ cpp/frams/config/f0-SDK.def	(revision 915)
@@ -48,4 +48,14 @@
 PROP(dz,1,1024,delta.z,f,-2,2,0,d.z)
 PROP(sh,1,0,shape,d,0,1,0,shape)
+PROP(hx,1,0,hinge position.x,f,,,0,hinge_pos.x)
+PROP(hy,1,1024,hinge position.y,f,,,0,hinge_pos.y)
+PROP(hz,1,1024,hinge position.z,f,,,0,hinge_pos.z)
+PROP(hrx,1,0,hinge rotation.x,f,,,0,hinge_rot.x)
+PROP(hry,1,1024,hinge rotation.y,f,,,0,hinge_rot.y)
+PROP(hrz,1,1024,hinge rotation.z,f,,,0,hinge_rot.z)
+PROP(hxn,1,0,hinge x negative limit,f,-6.2832,0,-1.5708,hinge_limit_x[0])
+PROP(hxp,1,1024,hinge x positive limit,f,0,6.2832,1.5708,hinge_limit_x[1])
+PROP(hyn,1,0,hinge y negative limit,f,-6.2832,0,-1.5708,hinge_limit_y[0])
+PROP(hyp,1,1024,hinge y positive limit,f,0,6.2832,1.5708,hinge_limit_y[1])
 XPROP(stif,2,0,stiffness,f,0.0,1.0,1.0,stif)
 XPROP(rotstif,2,0,rotation stiffness,f,0.0,1.0,1.0,rotstif)
@@ -66,4 +76,14 @@
 PROP(p2,0,1024,`part2 ref#',d,-1,999999,-1,p2_refno)
 PROP(sh,1,0,shape,d,0,1,0,shape)
+PROP(hx,1,0,hinge position.x,f,,,0,hinge_pos.x)
+PROP(hy,1,1024,hinge position.y,f,,,0,hinge_pos.y)
+PROP(hz,1,1024,hinge position.z,f,,,0,hinge_pos.z)
+PROP(hrx,1,0,hinge rotation.x,f,,,0,hinge_rot.x)
+PROP(hry,1,1024,hinge rotation.y,f,,,0,hinge_rot.y)
+PROP(hrz,1,1024,hinge rotation.z,f,,,0,hinge_rot.z)
+PROP(hxn,1,0,hinge x negative limit,f,-6.2832,0,-1.5708,hinge_limit_x[0])
+PROP(hxp,1,1024,hinge x positive limit,f,0,6.2832,1.5708,hinge_limit_x[1])
+PROP(hyn,1,0,hinge y negative limit,f,-6.2832,0,-1.5708,hinge_limit_y[0])
+PROP(hyp,1,1024,hinge y positive limit,f,0,6.2832,1.5708,hinge_limit_y[1])
 XPROP(stif,2,0,stiffness,f,0.0,1.0,1.0,stif)
 XPROP(rotstif,2,0,rotation stiffness,f,0.0,1.0,1.0,rotstif)
Index: cpp/frams/config/f0.def
===================================================================
--- cpp/frams/config/f0.def	(revision 826)
+++ cpp/frams/config/f0.def	(revision 915)
@@ -13,9 +13,9 @@
 PROP(y,0,1024,position.y,f,,,,p.y)
 PROP(z,0,1024,position.z,f,,,,p.z)
-PROP(sh,1,0,shape,d,0,3,0,shape)
-PROP(s,1,0,size,f,0.1,10.0,1.0,size)
-PROP(sx,1,0,scale.x,f,0.001,1000.0,1.0,scale.x)
-PROP(sy,1,0,scale.y,f,0.001,1000.0,1.0,scale.y)
-PROP(sz,1,0,scale.z,f,0.001,1000.0,1.0,scale.z)
+PROP(sh,0,0,shape,d,0,3,0,shape)
+PROP(s,0,0,size,f,0.1,10.0,1.0,size)
+PROP(sx,0,0,scale.x,f,0.001,1000.0,1.0,scale.x)
+PROP(sy,0,0,scale.y,f,0.001,1000.0,1.0,scale.y)
+PROP(sz,0,0,scale.z,f,0.001,1000.0,1.0,scale.z)
 XPROP(h,1,0,hollow,f,0,1,0,hollow)
 XPROP(dn,1,0,density,f,0.2,5.0,1.0,density)
@@ -47,5 +47,15 @@
 PROP(dy,1,1024,delta.y,f,-2,2,0,d.y)
 PROP(dz,1,1024,delta.z,f,-2,2,0,d.z)
-PROP(sh,2,0,shape,d,0,1,0,shape)
+PROP(sh,1,0,shape,d,0,3,0,shape)
+PROP(hx,1,0,hinge position.x,f,,,0,hinge_pos.x)
+PROP(hy,1,1024,hinge position.y,f,,,0,hinge_pos.y)
+PROP(hz,1,1024,hinge position.z,f,,,0,hinge_pos.z)
+PROP(hrx,1,0,hinge rotation.x,f,,,0,hinge_rot.x)
+PROP(hry,1,1024,hinge rotation.y,f,,,0,hinge_rot.y)
+PROP(hrz,1,1024,hinge rotation.z,f,,,0,hinge_rot.z)
+PROP(hxn,1,0,hinge x negative limit,f,-6.2832,0,-1.5708,hinge_limit_x[0])
+PROP(hxp,1,1024,hinge x positive limit,f,0,6.2832,1.5708,hinge_limit_x[1])
+PROP(hyn,1,0,hinge y negative limit,f,-6.2832,0,-1.5708,hinge_limit_y[0])
+PROP(hyp,1,1024,hinge y positive limit,f,0,6.2832,1.5708,hinge_limit_y[1])
 XPROP(stif,2,0,stiffness,f,0.0,1.0,1.0,stif)
 XPROP(rotstif,2,0,rotation stiffness,f,0.0,1.0,1.0,rotstif)
@@ -65,5 +75,15 @@
 PROP(p1,0,1024,`part1 ref#',d,-1,999999,-1,p1_refno)
 PROP(p2,0,1024,`part2 ref#',d,-1,999999,-1,p2_refno)
-PROP(sh,2,0,shape,d,0,1,0,shape)
+PROP(sh,1,0,shape,d,0,3,0,shape)
+PROP(hx,1,0,hinge position.x,f,,,0,hinge_pos.x)
+PROP(hy,1,1024,hinge position.y,f,,,0,hinge_pos.y)
+PROP(hz,1,1024,hinge position.z,f,,,0,hinge_pos.z)
+PROP(hrx,1,0,hinge rotation.x,f,,,0,hinge_rot.x)
+PROP(hry,1,1024,hinge rotation.y,f,,,0,hinge_rot.y)
+PROP(hrz,1,1024,hinge rotation.z,f,,,0,hinge_rot.z)
+PROP(hxn,1,0,hinge x negative limit,f,-6.2832,0,-1.5708,hinge_limit_x[0])
+PROP(hxp,1,1024,hinge x positive limit,f,0,6.2832,1.5708,hinge_limit_x[1])
+PROP(hyn,1,0,hinge y negative limit,f,-6.2832,0,-1.5708,hinge_limit_y[0])
+PROP(hyp,1,1024,hinge y positive limit,f,0,6.2832,1.5708,hinge_limit_y[1])
 XPROP(stif,2,0,stiffness,f,0.0,1.0,1.0,stif)
 XPROP(rotstif,2,0,rotation stiffness,f,0.0,1.0,1.0,rotstif)