Index: js/human_3d_alignment/src/index.jsx
===================================================================
--- js/human_3d_alignment/src/index.jsx	(revision 918)
+++ js/human_3d_alignment/src/index.jsx	(revision 942)
@@ -53,9 +53,9 @@
         window.logger = new Module.LoggerToStdout(Module.LoggerBase.Enable); // While this object exists, all messages emitted by SDK loggers will be printf()'ed and consequently will appear in the JS console.
         this.layout = [
-            {name:'0,textviewer', x: 0, y: 0, w: 9, h: 1},
+            {name:'0,textviewer', x: 0, y: 0, w: 12, h: 1},
             {name:'2,similviewer', x: 0, y: 1, w: 6, h: 4},
             {name:'3,fitviewer', x: 6, y: 1, w: 6, h: 2},
             {name:'4,sliderviewer', x: 6, y: 3, w: 6, h: 2},
-            {name:'1,parmviewer', x: 9, y: 0, w: 3, h: 1}
+            {name:'1,parmviewer', x: 9, y: 6, w: 12, h: 1}
         ];
 
@@ -83,4 +83,18 @@
             selectedGender: {value: "empty", label: " "},
             selectedYear: {value: "empty", label: " "},
+            selectedSleepHours: {value: "empty", label: " "},
+            selectedSleepHoursToday: {value: "empty", label: " "},
+            selectedHand: {value: "empty", label: " "},
+            selectedYearsGamePlaying: {value: "empty", label: " "},
+            selectedHoursGamePlaying: {value: "empty", label: " "},
+            selectedMusicalExperience: {value: "empty", label: " "},
+            selectedMusicalDuration: {value: "empty", label: " "},
+            selectedLanguages: {value: "empty", label: " "},
+            selectedSportYears: {value: "empty", label: " "},
+            selectedSportHours: {value: "empty", label: " "},
+            selectedSportType: {value: "empty", label: " "},
+            selectedCons: {value: "empty", label: " "},
+            selectedCalculations: {value: "empty", label: " "},
+            selectedNavigation: {value: "empty", label: " "},
             percent: 0,
             sliderUpdated: true,
@@ -110,5 +124,19 @@
         this.handleChangeIp = this.handleChangeIp.bind(this);
         this.handleChangeGender =  this.handleChangeGender.bind(this);
+        this.handleChangeHand =  this.handleChangeHand.bind(this);
+        this.handleChangeYearsGamePlaying =  this.handleChangeYearsGamePlaying.bind(this);
+        this.handleChangeHoursGamePlaying =  this.handleChangeHoursGamePlaying.bind(this);
         this.handleChangeYear = this.handleChangeYear.bind(this);
+        this.handleChangeSleepHours = this.handleChangeSleepHours.bind(this);
+        this.handleChangeSleepHoursToday = this.handleChangeSleepHoursToday.bind(this);
+        this.handleChangeMusicalExperience = this.handleChangeMusicalExperience.bind(this);
+        this.handleChangeMusicalDuration = this.handleChangeMusicalDuration.bind(this);
+        this.handleChangeLanguages = this.handleChangeLanguages.bind(this);
+        this.handleChangeSportYears = this.handleChangeSportYears.bind(this);
+        this.handleChangeSportHours = this.handleChangeSportHours.bind(this);
+        this.handleChangeSportType = this.handleChangeSportType.bind(this);
+        this.handleChangeCons = this.handleChangeCons.bind(this);
+        this.handleChangeCalculations = this.handleChangeCalculations.bind(this);
+        this.handleChangeNavigation = this.handleChangeNavigation.bind(this);
         this.handleChangePercent = this.handleChangePercent.bind(this);
         this.handleChangeStartTime = this.handleChangeStartTime.bind(this);
@@ -144,5 +172,6 @@
         this.getIp();   //set user ip
         this.genotypes = new Genotypes(this, "https://raw.githubusercontent.com/arturolejnik95/human_3d_alignment/master/walking.gen");   //load text from file to this.genotypes
-        let head = "'User ID'|'User IP'|'Gender'|'Year of born'|'Start time'|'Stop time'|'Position of 1st'|'Position of 2nd'|'Rotation of 1st'|'Rotation of 2nd'|'ID 1st'|'ID 2nd'|'Fit'|'Result'\n"
+        //or another URL...
+        let head = "'User ID'|'User IP'|'Gender'|'Year of birth'|'Handeness'|'Sleep hours'|'Sleep hours today'|'YearsGamePlaying'|'HoursGamePlaying'|'Musical experience'|'MusicalDuration'|'Languages'|'SportYears'|'SportHours'|'SportType'|'Cons'|'Calculations'|'Navigation'|'Start time'|'Stop time'|'Position of 1st'|'Position of 2nd'|'Rotation of 1st'|'Rotation of 2nd'|'ID 1st'|'ID 2nd'|'Fit'|'Result'\n"
         this.handleChangeResult(head);
     }
@@ -207,4 +236,18 @@
                     this.state.selectedGender.value + '|' +
                     this.state.selectedYear.value + '|' +
+                    this.state.selectedHand.value + '|' +
+                    this.state.selectedSleepHours.value + '|' +
+                    this.state.selectedSleepHoursToday.value + '|' +
+                    this.state.selectedYearsGamePlaying.value + '|' +
+                    this.state.selectedHoursGamePlaying.value + '|' +
+                    this.state.selectedMusicalExperience.value + '|' +
+                    this.state.selectedMusicalDuration.value + '|' +
+                    this.state.selectedLanguages.value + '|' +
+                    this.state.selectedSportYears.value + '|' +
+                    this.state.selectedSportHours.value + '|' +
+                    this.state.selectedSportType.value + '|' +
+                    this.state.selectedCons.value + '|' +
+                    this.state.selectedCalculations.value + '|' +
+                    this.state.selectedNavigation.value + '|' +
                     start + '|' +
                     stop + '|' +
@@ -243,5 +286,5 @@
         });
         
-        rawFile.open("POST", 'https://ptsv2.com/t/b7nhq-1578108725/post');
+        rawFile.open("POST", 'https://ptsv2.com/t/b7nhq-1578108725/post'); //or another URL...
         rawFile.setRequestHeader("Content-type", 'text/plain');
         rawFile.send(fit);
@@ -331,8 +374,8 @@
 
     /**
-     * Check is user ready to go to the next question by checking choosed gender, birth year and percent of similarity
+     * Check if the user is ready to go to the next question by checking if all the answers are selected
      */
     isReady() {
-        if (this.state.selectedGender.value != 'empty' && this.state.selectedYear.value != 'empty' && this.state.sliderUpdated) {
+        if (this.state.selectedSportType.value != 'empty' && this.state.selectedYearsGamePlaying.value != 'empty' && this.state.selectedHoursGamePlaying.value != 'empty' && this.state.selectedMusicalDuration.value != 'empty' && this.state.selectedLanguages.value != 'empty' && this.state.selectedSportYears.value != 'empty' && this.state.selectedSportHours.value != 'empty' && this.state.selectedCons.value != 'empty' && this.state.selectedCalculations.value != 'empty' && this.state.selectedNavigation.value != 'empty' && this.state.selectedMusicalExperience.value != 'empty' && this.state.selectedGender.value != 'empty' && this.state.selectedSleepHoursToday.value != 'empty' && this.state.selectedSleepHours.value != 'empty' && this.state.selectedHand.value != 'empty' && this.state.selectedYear.value != 'empty' && this.state.sliderUpdated) {
             this.setState({isDisable: false}, function() {
                 console.log(this.state.isDisable);
@@ -393,5 +436,137 @@
         this.setState({ selectedGender: gen }, function() {
             console.log(`Gender selected:`, this.state.selectedGender);
+            this.isReady();
+        });
+    };
+    
+     /**
+     * Allow to change sport type in state
+     * @param {string} sport type choosed sport type by user in listbox 
+     */
+    handleChangeSportType(sporttype) {
+        this.setState({ selectedSportType: sporttype }, function() {
+            console.log(`Sport type selected:`, this.state.selectedSportType);
+            this.isReady();
+        });
+    };
+    
+	 /**
+     * Allow to years game playing type in state
+     * @param {string} gameyp type choosed years game playing by user in listbox 
+     */
+    handleChangeYearsGamePlaying(gameyp) {
+        this.setState({ selectedYearsGamePlaying: gameyp }, function() {
+            console.log(`Years game playing selected:`, this.state.selectedYearsGamePlaying);
+            this.isReady();
+        });
+    };
+
+	 /**
+     * Allow to hours game playing type in state
+     * @param {string} gamehp type choosed hours game playing by user in listbox 
+     */    
+    handleChangeHoursGamePlaying(gamehp) {
+        this.setState({ selectedHoursGamePlaying: gamehp }, function() {
+            console.log(`Hours game playing selected:`, this.state.selectedHoursGamePlaying);
             console.log(this.genotypes.id.length)
+            this.isReady();
+        });
+    };
+    
+    /**
+     * Allow to change musical expereince in state
+     * @param {string} musexp choosed musical expereince by user in listbox 
+     */
+    handleChangeMusicalExperience(musexp) {
+        this.setState({ selectedMusicalExperience: musexp }, function() {
+            console.log(`Musical experience selected:`, this.state.selectedMusicalExperience);
+            this.isReady();
+        });
+    };
+    
+     /**
+     * Allow to change hand in state
+     * @param {string} hand choosed hand by user in listbox 
+     */
+    handleChangeHand(hand) {
+        this.setState({ selectedHand: hand }, function() {
+            console.log(`Hand selected:`, this.state.selectedHand);
+            this.isReady();
+        });
+    };
+    
+     /**
+     * Allow to change musical duration in state
+     * @param {string} musdur choosed musical duration by user in listbox 
+     */
+    handleChangeMusicalDuration(musdur) {
+        this.setState({ selectedMusicalDuration: musdur }, function() {
+            console.log(`Musical hours selected:`, this.state.selectedMusicalDuration);
+            this.isReady();
+        });
+    };
+    
+     /**
+     * Allow to languages hand in state
+     * @param {string} languages choosed languages by user in listbox 
+     */
+    handleChangeLanguages(languages) {
+        this.setState({ selectedLanguages: languages }, function() {
+            console.log(`Languages selected:`, this.state.selectedLanguages);
+            this.isReady();
+        });
+    };
+    
+    /**
+     * Allow to change sport years hand in state
+     * @param {string} sportyr choosed sport years by user in listbox 
+     */
+    handleChangeSportYears(sportyr) {
+        this.setState({ selectedSportYears: sportyr }, function() {
+            console.log(`Sport years selected:`, this.state.selectedSportYears);
+            this.isReady();
+        });
+    };
+    
+     /**
+     * Allow to change sport hours in state
+     * @param {string} sporthr choosed sport hours by user in listbox 
+     */
+    handleChangeSportHours(sporthr) {
+        this.setState({ selectedSportHours: sporthr }, function() {
+            console.log(`Sport hours selected:`, this.state.selectedSportHours);
+            this.isReady();
+        });
+    };
+    
+    /**
+     * Allow to change conscientiousness in state
+     * @param {string} cons choosed hand by user in listbox 
+     */
+    handleChangeCons(cons) {
+        this.setState({ selectedCons: cons }, function() {
+            console.log(`Conscientiousness selected:`, this.state.selectedCons);
+            this.isReady();
+        });
+    };
+    
+     /**
+     * Allow to change calculations in state
+     * @param {string} calculations choosed calculations by user in listbox 
+     */
+    handleChangeCalculations(calculations) {
+        this.setState({ selectedCalculations: calculations }, function() {
+            console.log(`Calculations selected:`, this.state.selectedCalculations);
+            this.isReady();
+        });
+    };
+    
+     /**
+     * Allow to change navigation in state
+     * @param {string} navigation choosed navigation by user in listbox 
+     */
+    handleChangeNavigation(navigation) {
+        this.setState({ selectedNavigation: navigation }, function() {
+            console.log(`Navigation selected:`, this.state.selectedNavigation);
             this.isReady();
         });
@@ -435,4 +610,26 @@
         this.setState({ selectedYear: year }, function() {
             console.log(`Birth year selected:`, this.state.selectedYear);
+            this.isReady();
+        });
+    }
+
+        /**
+     * Allow to change birth year in state
+     * @param {number} year choosed birth year by user in listbox
+     */
+    handleChangeSleepHours(hours) {
+        this.setState({ selectedSleepHours: hours }, function() {
+            console.log(`Birth year selected:`, this.state.selectedSleepHours);
+            this.isReady();
+        });
+    }
+    
+            /**
+     * Allow to change birth year in state
+     * @param {number} year choosed birth year by user in listbox
+     */
+    handleChangeSleepHoursToday(hours) {
+        this.setState({ selectedSleepHoursToday: hours }, function() {
+            console.log(`Birth year selected:`, this.state.selectedSleepHoursToday);
             this.isReady();
         });
@@ -666,6 +863,20 @@
                 case 'parmviewer':
                     items.push({content: <ParmViewer 
-                            handleChangeYear = {(year) => {this.handleChangeYear(year)}} 
+                            handleChangeYear = {(year) => {this.handleChangeYear(year)}}
+                            handleChangeSleepHours = {(hours) => {this.handleChangeSleepHours(hours)}}
+                            handleChangeSleepHoursToday = {(hours) => {this.handleChangeSleepHoursToday(hours)}}                            
                             handleChangeGender = {(gen) => {this.handleChangeGender(gen)}}
+                            handleChangeSportType = {(gen) => {this.handleChangeSportType(gen)}}
+                            handleChangeMusicalExperience = {(gen) => {this.handleChangeMusicalExperience(gen)}}
+                            handleChangeHand = {(hand) => {this.handleChangeHand(hand)}}
+                            handleChangeYearsGamePlaying = {(hand) => {this.handleChangeYearsGamePlaying(hand)}}
+                            handleChangeHoursGamePlaying = {(hand) => {this.handleChangeHoursGamePlaying(hand)}}
+                            handleChangeMusicalDuration = {(hand) => {this.handleChangeMusicalDuration(hand)}}
+                            handleChangeLanguages = {(hand) => {this.handleChangeLanguages(hand)}}
+                            handleChangeSportHours = {(hand) => {this.handleChangeSportHours(hand)}}
+                            handleChangeSportYears = {(hand) => {this.handleChangeSportYears(hand)}}
+                            handleChangeCons = {(hand) => {this.handleChangeCons(hand)}}
+                            handleChangeCalculations = {(hand) => {this.handleChangeCalculations(hand)}}
+                            handleChangeNavigation = {(hand) => {this.handleChangeNavigation(hand)}}                                                
                         />, 
                         i: "" + i + 'parmviewer',
@@ -718,5 +929,5 @@
             <span>   
                 <span style={{marginLeft: '20px', fontFamily: "'Fira Mono', Monaco, 'Andale Mono', 'Lucida Console', 'Bitstream Vera Sans Mono', 'Courier New', Courier, monospace"}}>
-                    Ankieta
+                    Badanie
                 </span> 
             </span>
Index: js/human_3d_alignment/src/widgets/parmviewer.jsx
===================================================================
--- js/human_3d_alignment/src/widgets/parmviewer.jsx	(revision 918)
+++ js/human_3d_alignment/src/widgets/parmviewer.jsx	(revision 942)
@@ -11,4 +11,11 @@
 ];
 
+const hands = [
+    { value: 'empty', label: ' ' },
+    { value: 'left', label: 'Lewa' },
+    { value: 'right', label: 'Prawa' },
+    { value: 'both', label: 'Obie' }
+];
+
 const currentYear = new Date().getFullYear();
 
@@ -16,7 +23,62 @@
 years.push({value: 'empty', label: ' '})
     
-for (let i = 0; i < 120; i += 1) {
+for (let i = 0; i < 50; i += 1) {
     years.push({ value: currentYear - i, label: currentYear - i });
 }
+
+const hours = [];
+hours.push({value: 'empty', label: ' '})
+    
+for (let i = 0; i < 16.5; i += 0.5) {
+    hours.push({ value: i, label: i });
+}
+
+const hours_week = [];
+hours_week.push({value: 'empty', label: ' '})
+    
+for (let i = 0; i < 26; i += 1) {
+    hours_week.push({ value: i, label: i });
+}
+
+const years_num = [];
+years_num.push({value: 'empty', label: ' '})
+    
+for (let i = 0; i < 31; i += 1) {
+    years_num.push({ value: i, label: i });
+}
+
+const language_num = [];
+language_num.push({value: 'empty', label: ' '})
+    
+for (let i = 0; i < 11; i += 1) {
+    language_num.push({ value: i, label: i });
+}
+
+const likert = [];
+likert.push({value: 'empty', label: ' '})
+likert.push({value: 'definetely_not', label: 'zdecydowanie się nie zgadzam'})
+likert.push({value: 'rather_not', label: 'raczej się nie zgadzam'})
+likert.push({value: 'undecided', label: 'trudno powiedzieć'})
+likert.push({value: 'rather_yes', label: 'raczej się zgadzam'})
+likert.push({value: 'definetely_yes', label: 'zdecydowanie się zgadzam'})
+
+const yes_no = [];
+yes_no.push({value: 'empty', label: ' '});
+yes_no.push({value: 'yes', label: 'tak'});
+yes_no.push({value: 'no', label: 'nie'});
+
+const musical_level = [];
+musical_level.push({value: 'empty', label: ' '});
+musical_level.push({value: 'amateur', label: 'amatorsko'});
+musical_level.push({value: 'proffesional', label: 'profesjonalnie'});
+musical_level.push({value: 'none', label: 'wcale'});
+
+const sports = [];
+sports.push({value: 'empty', label: ' '});
+sports.push({value: 'none', label: 'nie uprawiam sportu'});
+sports.push({value: 'cardio', label: 'wytrzymałościowy'});
+sports.push({value: 'strength', label: 'siłowy'});
+sports.push({value: 'intellectual', label: 'intelektualny'});
+sports.push({value: 'combination', label: 'jakaś kombinacja powyższych'});
 
 const styles = {
@@ -66,4 +128,5 @@
         this.state = {};
     }
+
      
     render() {
@@ -98,4 +161,188 @@
                     <div style={styles.ind}/>
                 </div>
+                    <div className='hand' style={styles.row}>
+                    <span htmlFor="hand" style={styles.desc}>Dominująca ręka</span>
+                    <Select
+                        options={hands}
+                        onChange={this.props.handleChangeHand}
+                        placeholder='Wybierz dominującą rękę'
+                        display={'table-cell'}
+                        height={'20px'}
+                        styles={styles.select}
+                        noValidate
+                    />
+                    <div style={styles.ind}/>
+                </div>                
+                <div className='sleep_hours' style={styles.row}>
+                    <span htmlFor="sleep_hours" style={styles.desc}>Średnia liczba godzin snu</span>
+                    <Select 
+                        options={hours}
+                        onChange={this.props.handleChangeSleepHours}
+                        placeholder={'Wybierz średnią liczbę godzin snu'}
+                        display={'table-cell'}
+                        height={'20px'} 
+                        styles={styles.select}
+                        noValidate
+                    />
+                    <div style={styles.ind}/>
+                </div>
+                <div className='sleep_hours_today' style={styles.row}>
+                    <span htmlFor="sleep_hours_today" style={styles.desc}>Liczba godzin snu dzisiaj</span>
+                    <Select 
+                        options={hours}
+                        onChange={this.props.handleChangeSleepHoursToday}
+                        placeholder={'Wybierz liczbę godzin snu dzisiejszej nocy'}
+                        display={'table-cell'}
+                        height={'20px'} 
+                        styles={styles.select}
+                        noValidate
+                    />
+                    <div style={styles.ind}/>
+                </div>
+                <div className='years_game_playing' style={styles.row}>
+                    <span htmlFor="years_game_playing" style={styles.desc}>Liczba lat grania w gry komputerowe</span>
+                    <Select 
+                        options={years_num}
+                        onChange={this.props.handleChangeYearsGamePlaying}
+                        placeholder={'Wybierz liczbę lat grania w gry komputerowe'}
+                        display={'table-cell'}
+                        height={'20px'} 
+                        styles={styles.select}
+                        noValidate
+                    />
+                    <div style={styles.ind}/>
+                </div>
+                <div className='hours_game_playing' style={styles.row}>
+                    <span htmlFor="hours_game_playing" style={styles.desc}>Średnio godzin grania w gry komputerowe na dobę</span>
+                    <Select 
+                        options={hours}
+                        onChange={this.props.handleChangeHoursGamePlaying}
+                        placeholder={'Wybierz średnią liczbę godzin grania w gry komputerowe na dobę'}
+                        display={'table-cell'}
+                        height={'20px'} 
+                        styles={styles.select}
+                        noValidate
+                    />
+                    <div style={styles.ind}/>
+                </div>
+                <div className='musical_experience' style={styles.row}>
+                    <span htmlFor="musical_experience" style={styles.desc}>Gram na instrumencie lub śpiewam: poziom</span>
+                    <Select 
+                        options={musical_level}
+                        onChange={this.props.handleChangeMusicalExperience}
+                        placeholder={'Wybierz na jakim poziomie grasz na instrumencie lub śpiewasz'}
+                        display={'table-cell'}
+                        height={'20px'} 
+                        styles={styles.select}
+                        noValidate
+                    />
+                    <div style={styles.ind}/>
+                </div>
+                <div className='musical_duration' style={styles.row}>
+                    <span htmlFor="musical_duration" style={styles.desc}>Gram na instrumencie lub śpiewam: liczba lat</span>
+                    <Select 
+                        options= {years_num}
+                        onChange={this.props.handleChangeMusicalDuration}
+                        placeholder={'Wybierz ile lat grasz na instrumencie lub śpiewasz'}
+                        display={'table-cell'}
+                        height={'20px'} 
+                        styles={styles.select}
+                        noValidate
+                    />
+                    <div style={styles.ind}/>
+                </div>
+                <div className='languages' style={styles.row}>
+                    <span htmlFor="languages" style={styles.desc}>Liczba języków obcych</span>
+                    <Select 
+                        options= {language_num}
+                        onChange={this.props.handleChangeLanguages}
+                        placeholder={'Wybierz ilu języków obcych się uczysz/uczyłeś/uczyłaś'}
+                        display={'table-cell'}
+                        height={'20px'} 
+                        styles={styles.select}
+                        noValidate
+                    />
+                    <div style={styles.ind}/>
+                </div>
+                <div className='sport_years' style={styles.row}>
+                    <span htmlFor="sport_years" style={styles.desc}>Liczba lat treningu sportowego</span>
+                    <Select 
+                        options= {years_num}
+                        onChange={this.props.handleChangeSportYears}
+                        placeholder={'Wybierz od ilu lat uprawiasz sport'}
+                        display={'table-cell'}
+                        height={'20px'} 
+                        styles={styles.select}
+                        noValidate
+                    />
+                    <div style={styles.ind}/>
+                </div>
+                <div className='sport_hours' style={styles.row}>
+                    <span htmlFor="sport_hours" style={styles.desc}>Liczba godzin treningu sportowego tygodniowo</span>
+                    <Select 
+                        options= {hours_week}
+                        onChange={this.props.handleChangeSportHours}
+                        placeholder={'Wybierz ile godzin tygodniowo uprawiasz sport'}
+                        display={'table-cell'}
+                        height={'20px'} 
+                        styles={styles.select}
+                        noValidate
+                    />
+                    <div style={styles.ind}/>
+                </div>
+                <div className='sport_type' style={styles.row}>
+                    <span htmlFor="sport_type" style={styles.desc}>Typ aktywności sportowej</span>
+                    <Select 
+                        options= {sports}
+                        onChange={this.props.handleChangeSportType}
+                        placeholder={'Wybierz typ aktywności sportowej'}
+                        display={'table-cell'}
+                        height={'20px'} 
+                        styles={styles.select}
+                        noValidate
+                    />
+                    <div style={styles.ind}/>
+                </div>
+                
+                <div style={styles.interval}/>
+                <div className='cons' style={styles.row}>
+                    <span htmlFor="cons" style={styles.desc}>Uważam się za osobę sumienną</span>
+                    <Select 
+                        options= {likert}
+                        onChange={this.props.handleChangeCons}
+                        placeholder={'Wybierz na ile zgadzasz się ze zdaniem po lewej'}
+                        display={'table-cell'}
+                        height={'20px'} 
+                        styles={styles.select}
+                        noValidate
+                    />
+                    <div style={styles.ind}/>
+                </div>
+                <div className='calculations' style={styles.row}>
+                    <span htmlFor="calculations" style={styles.desc}>Uważam, że sprawnie wykonuję obliczenia w pamięci</span>
+                    <Select 
+                        options= {likert}
+                        onChange={this.props.handleChangeCalculations}
+                        placeholder={'Wybierz na ile zgadzasz się ze zdaniem po lewej'}
+                        display={'table-cell'}
+                        height={'20px'} 
+                        styles={styles.select}
+                        noValidate
+                    />
+                    <div style={styles.ind}/>
+                </div>
+                <div className='navigation' style={styles.row}>
+                    <span htmlFor="navigation" style={styles.desc}>Uważam, że sprawnie posługuję się mapą/nawigacją i dobrze orientuję się w terenie</span>
+                    <Select 
+                        options= {likert}
+                        onChange={this.props.handleChangeNavigation}
+                        placeholder={'Wybierz na ile zgadzasz się ze zdaniem po lewej'}
+                        display={'table-cell'}
+                        height={'20px'} 
+                        styles={styles.select}
+                        noValidate
+                    />
+                    <div style={styles.ind}/>
+                </div>
             </div>
         );